<template>
  <div class="query-panel flex-grow-0 flex-column" v-bind:class="displayClass">
    <div class="d-flex flex-grow-1 flex-row bg-light">
      <div class="d-flex flex-grow-0 align-items-start mr-auto">
        <button class="btn btn-light"
          :class="isPanelActive('info-table')"
          @click="currentPanel = 'info-table'">
          Tabela
        </button>
        <button class="btn btn-light"
          :class="isPanelActive('chart-panel')"
          @click="currentPanel = 'chart-panel'">
          Gráfico
        </button>
        <button class="btn btn-light"
          :class="isPanelActive('skewt-panel')"
          @click="currentPanel = 'skewt-panel'">
          Tefigrama
        </button>
        <div class="btn btn-light">
          <router-link :to="detailPage" target="_blank">Detalhe</router-link>
        </div>
      </div>

      <div class="d-flex flex-grow-0 align-items-end">
        <button class="btn btn-primary" @click="close">
          <font-awesome-icon icon="times"></font-awesome-icon>
        </button>
      </div>
    </div>

    <div v-show="currentPanel === 'info-table'">
      <info-table name="info-table"></info-table>
    </div>
    <div v-show="currentPanel === 'chart-panel'">
      <info-container name="chart-panel">
        <info-chart name="chart-panel"></info-chart>
      </info-container>
    </div>
    <div v-show="currentPanel === 'skewt-panel'">
      <skewt-panel name="skewt-panel"></skewt-panel>
    </div>
  </div>
</template>

<script>
// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'

// Store
import { SET_QUERY, mutationNameResolve } from '@/store/workspace/mutations'

// Components
import InfoTable from './InfoTable'
import SkewtPanel from './SkewtPanel'
import InfoChart from './InfoChart'
import InfoContainer from './InfoContainer'


export default {
  name: 'querypanel',

  mixins: [
    ParentWorkspaceMixin,
  ],

  data() {
    return {
      currentPanel: 'info-table',
    }
  },

  computed: {
    // Access the current query object stored in the workspace vuex state
    // object.
    query: {
      get() {
        return this.$store.state[this.workspace].query
      },
    },

    // Access the current query point
    queryPoint: {
      get() {
        return this.query ? this.$store.getters.getLocationById(this.query.id) : null
      },
    },

    // Show the panel if the current query object is not empty
    displayClass: {
      get() {
        return this.query !== null ? 'd-flex' : 'd-none'
      }
    },

    // Current referenceTime for the workspace
    referenceTime: {
      get() {
        return this.$store.state[this.workspace].referenceTime
      },
    },

    // Tests if the QueryPanel is being shown
    isShown: {
      get() {
        return this.displayClass === 'd-flex'
      }
    },

    detailPage: {
      get() {
        if(this.queryPoint === null) return { name: 'main' }
        return {
          name: 'detail',
          params: {
            latitude: this.queryPoint.latitude,
            longitude: this.queryPoint.longitude,
            datetime: this.referenceTime,
          }
        }
      }
    },
  },

  methods: {
    // Close the query panel by setting the current query to null.
    close() {
      this.$store.commit(mutationNameResolve(this.workspace, SET_QUERY), { query: null })
    },

    isPanelActive(name) {
      return {
        active: name === this.currentPanel
      }
    },
  },

  components: {
    InfoTable,
    SkewtPanel,
    InfoChart,
    InfoContainer,
  },
}
</script>

<style scoped>
div.d-flex button.btn {
  border-radius: 0 !important;
}

div.d-flex.flex-grow-0 div.btn a {
  color: #212529 !important;
}
</style>
